#include <iostream>
#include <algorithm>

using namespace std;

const int delta = 29123;

bool p[delta + 1]; // p[i] = false <-> i is prime
int d[delta + 1];

int main() {
	// int delta; cin >> delta;

	p[0] = p[1] = true;
	for (int i = 2; i <= delta; i++) if (!p[i])
		for (int j = 2 * i; j <= delta; j += i) p[j] = true;

	for (int i = 11; i < delta; i++) if (!p[i]) {
		// find leftmost digit and length of i
		int x = i, l = 1;
		while (x > 9) x /= 10, l++;

		d[i % 10] = max (d[i % 10], max (d[x] - 1, 0) + l);
	}

	long long ans = *max_element (d, d + 10);
	cerr << ans << endl;
	cout << (ans * ans * ans) % delta << endl;
	return 0;
}
