#include <iostream>

using namespace std;

const int delta = 29123;

// The mysterious function inside the blackbox!
int process(long long x) {
	int y = 0;
	if (x % 2) return -1;
	for (x = x / 2; x > 1; x = x / 2) {
		int b = (x + 1) % 2;
		int k = 0;
		for (int i=y+2; i>2; i--)
			k++;
		y += k;
		y += b;
	}
	return y;
}

int main() {
	long long alpha = 1; // the input number

	int x = delta * delta;
	while (x > 0) {
		alpha = 2 * alpha + (1 - x % 2);
		x /= 2;
	}
	alpha *= 2;

	// proccess the input using the process() function
	int output = process(alpha);

	// pass the result to the LOCK of the BIG ENTRANCE DOOR
	cerr << output << endl;
	// expected result
	cerr << delta * delta << endl;

	// generated key
	cout << alpha << endl;

	return 0;
}
